if(!isobject(wrenchDetailFlagsDlg)) exec("./wrenchDetailFlagsDlg.gui");

function ClientCmdwrenchDetailFlagsDlgGetDetail(%index, %name, %list, %curvalue)
{
	if(%index == 1) {
		wrenchDetailFlagsDlgClear();
		canvas.pushDialog(wrenchDetailFlagsDlg);
	}
	$wrenchDetailFlagCount++;
	if($wrenchDetailFlagCount != %index) {
		ClientCmdMessageBoxOK("ERROR", "There was an error in retrieving the flag data; Please try re-wrenching the brick. (ERROR 101)");
		CommandToServer('wrenchDetailFlagsDlgError', 101);
		return;
	} else if($wrenchDetailFlagCount >= 1000) {
		ClientCmdMessageBoxOK("ERROR", "Too many flags provided by the server; please contact an administrator. (ERROR 102)");
		CommandToServer('wrenchDetailFlagsDlgError', 102);
		return;
	} else if(%index < 1 || %name $= "" || %list $= "") {
		ClientCmdMessageBoxOK("ERROR", "Invalid flag parameters provided by the server; please contact an administrator. (ERROR 103-" @ %index @ ")");
		CommandToServer('wrenchDetailFlagsDlgError', 103, %index);
		return;
	}
	if(%index < 100) {
		if(%index < 10) %ct = "00" @ %index;
		else %ct = "0" @ %index;
	} else %ct = %index;
	if(%index < 7) WrenchDetailFlagsDlgScrollSwatch.extent = "210 270";
	else WrenchDetailFlagsDlgScrollSwatch.extent = "470" SPC (%index * 45);
	WrenchDetailFlagsDlgScrollSwatch.setvisible(1); //forces the scrollbar to correct itself
		
	%swatch = new GUISwatchCtrl("wrenchDetailFlagSwatch" @ %ct) {
		position = "5" SPC ((%index - 1) * 45);
		nativepos = "5" SPC ((%index - 1) * 45);
		extent = "211 45";
		color = "192 192 192 255";
		name = %name;
	};
	WrenchDetailFlagsDlgScrollSwatch.add(%swatch);
	
	%add = new GuiTextCtrl() {
		position = "10 14";
		extent = "400 29";
		text = %name;
	};
	%swatch.add(%add);
	%add = new GuiPopUpMenuCtrl("wrenchDetailFlagDoodad" @ %ct) {
		position = "100 13";
		extent = "100 20";
	};
	for(%i = 0	; %i < getWordCount(%list); %i++) {
		%word = getword(%list, %i);
		%add.add(%word, %i+1);
		if(%word $= %curvalue) %curindex = %i+1;
	}
	if(!%curindex) %curindex = 1;
	%swatch.add(%add);
	%add.setSelected(%curindex);
}

function wrenchDetailFlagsDlgClear()
{
	for(%i = 1; %i <= $wrenchDetailFlagCount; %i++) {
		if(%i >= 10) {
			if(%i >= 100) %ct = %i;
			else %ct = "0" @ %i;
		} else %ct = "00" @ %i;
		%name = "wrenchDetailFlagSwatch" @ %ct;
		eval(%name @ ".delete();");
	}
	$wrenchDetailFlagCount = 0;
}

function wrenchDetailFlagsDlg::send()
{
	canvas.popdialog(wrenchDetailFlagsDlg);
	//gather up all the data and send it to the server
	for(%i = 1; %i <= $wrenchDetailFlagCount; %i++) {
		if(%i >= 10) {
			if(%i >= 100) %ct = %i;
			else %ct = "0" @ %i;
		} else %ct = "00" @ %i;
		%doodad = "wrenchDetailFlagDoodad" @ %ct;
		%sendstring = %sendstring SPC %doodad.getvalue();
	}
	commandToServer('SendDetailFlags', trim(%sendstring));
}